Foreman - Bug #11571

lookup_value_matcher not populated on hosts table in DB migration
08/26/2015 07:54 AM - Dominic Cleal

Status: Closed
Priority: High
Assignee: Tom Caspy
Category: DB migrations
Target version: 1.10.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2638
Description

The AddLookupValueMatchToHostAndHostgroup migration added in #11425 doesn't populate the lookup_value_matcher field added
to the host table. It only updates the updated_at timestamp:

This causes all FQDN-specific matchers to no longer match, which could lead to severe misconfigurations.

2015-08-26T12:48:36 [sgl] [D] (0.1ms) begin transaction
== AddLookupValueMatchToHostAndHostgroup: migrating

—-— add_column (:hosts, :lookup_value_matcher, :string)

2015-08-26T12:48:36 [sqgl] [D] (0.7ms) ALTER TABLE "hosts" ADD "lookup_value_matcher" varchar (2
55)

-> 0.0013s
—— add_column (:hostgroups, :lookup_value_matcher, :string)
2015-08-26T12:48:36 [sgl] [D] (0.3ms) ALTER TABLE "hostgroups" ADD "lookup_value_matcher" wvarc
har (255)

-> 0.0006s
2015-08-26T12:48:36 [sgl] [D] Host::Managed Load (0.3ms) SELECT "hosts".* FROM "hosts" WHERE "h
osts"."type" IN ('Host::Managed') AND "hosts"."type" = 'Host::Managed' ORDER BY "hosts"."id" ASC L
IMIT 100
2015-08-26T12:48:36 [sgl] [D] Nic: :Base Load (0.1ms) SELECT "nics".* FROM "nics" WHERE "nics"."
host_id" = 82 ORDER BY identifier
2015-08-26T12:48:37 [sqgl] [D] (0.1lms) UPDATE "hosts" SET "updated_at" = '2015-08-26 11:48:37.0
09783' WHERE "hosts"."type" IN ('Host::Managed') AND "hosts"."id" = 82
2015-08-26T12:48:37 [sgl] [D] Nic::Base Load (0.1lms) SELECT "nics".* FROM "nics" WHERE "nics"."
host_id" = 109 ORDER BY identifier
2015-08-26T12:48:37 [sqgl] [D] Domain Load (0.1ms) SELECT "domains".* FROM "domains" WHERE "doma
ins"."id" = 4 ORDER BY domains.name LIMIT 1
2015-08-26T12:48:37 [sgl] [D] (0.2ms) UPDATE "hosts" SET "updated_at" = '2015-08-26 11:48:37.0
58461' WHERE "hosts"."type" IN ('Host::Managed') AND "hosts"."id" = 109
2015-08-26T12:48:37 [sgl] [D] Nic::Base Load (0.1ms) SELECT "nics".* FROM "nics" WHERE "nics"."
host_id"™ = 110 ORDER BY identifier
2015-08-26T12:48:37 [sgl] [D] Domain Load (0.1ms) SELECT "domains".* FROM "domains" WHERE "doma
ins"."id" = 6 ORDER BY domains.name LIMIT 1
2015-08-26T12:48:37 [sgl] [D] (0.1lms) UPDATE "hosts" SET "updated_at" = '2015-08-26 11:48:37.0
62754' WHERE "hosts"."type" IN ('Host::Managed') AND "hosts"."id" = 110
2015-08-26T12:48:37 [sgl] [D] Nic::Base Load (0.1ms) SELECT "nics".* FROM "nics" WHERE "nics"."
host_id" = 118 ORDER BY identifier
2015-08-26T12:48:37 [sgl] [D] Domain Load (0.1ms) SELECT "domains".* FROM "domains" WHERE "doma
ins"."id" = 6 ORDER BY domains.name LIMIT 1
2015-08-26T12:48:37 [sqgl] [D] (0.1lms) UPDATE "hosts" SET "updated_at" = '2015-08-26 11:48:37.0
65953"'" WHERE "hosts"."type" IN ('Host::Managed') AND "hosts"."id" = 118
2015-08-26T12:48:37 [sgl] [D] Nic::Base Load (0.1ms) SELECT "nics".* FROM "nics" WHERE "nics"."
host_id"™ = 168 ORDER BY identifier
2015-08-26T12:48:37 [sgl] [D] Domain Load (0.1ms) SELECT "domains".* FROM "domains" WHERE "doma
ins"."id" = 6 ORDER BY domains.name LIMIT 1
2015-08-26T12:48:37 [sqgl] [D] (0.1lms) UPDATE "hosts" SET "updated_at" = '2015-08-26 11:48:37.0
69205"' WHERE "hosts"."type" IN ('Host::Managed') AND "hosts"."id" = 168

2015-08-26T12:48:37 [sgl] [D] Nic: :Base Load (0.2ms) SELECT "nics".* FROM
host_id" = 170 ORDER BY identifier

2015-08-26T12:48:37 [sgl] [D] Domain Load (0.1ms) SELECT "domains".* FROM
ins"."id" = 13 ORDER BY domains.name LIMIT 1

2015-08-26T12:48:37 [sgl] [D] (0.1ms) UPDATE "hosts" SET "updated_at" =
72978' WHERE "hosts"."type" IN ('Host::Managed') AND "hosts"."id" = 170

sglite> select id, lookup_value_matcher from hosts;
82|
109]
110]
118
168
170]

Adding a Host.reset_column_information call seems to make it work properly.

"nics" WHERE

"domains"

WHERE

"nics"."

"doma

'2015-08-26 11:48:37.0

Related issues:
Related to Foreman - Bug #11425: add a real primary key to host and hostgroup... Closed

08/19/2015

Associated revisions

Revision 2ec73490 - 08/26/2015 06:57 PM - Tom Caspy

fixes #11571 - resetting column information in migration

History

#1 - 08/26/2015 07:54 AM - Dominic Cleal
- Related to Bug #11425: add a real primary key to host and hostgroup for lookup_values has_many added

#2 - 08/26/2015 08:51 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2638 added
- Pull request deleted ()

#3 - 08/26/2015 07:02 PM - Tom Caspy
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 2ec73490ed682f171bf4eedd979d2d0c84a1858d.

#4 - 08/27/2015 03:03 AM - Dominic Cleal

- Assignee set to Tom Caspy
